#Include Once "windows.bi"

'=============================================================================
'																		Makros
'=============================================================================

#Macro LL_DeclaresF(Grundtyp,Datentyp,ParDef)
	Declare Property Grundtyp (index As Integer) As Datentyp Ptr
	Declare Function Grundtyp##Add ParDef As Integer
	Declare Function Grundtyp##Remove (index As Integer = -1) As Integer
	Declare Function Grundtyp##Count () As Integer
	Declare Function Grundtyp##Clear () As Integer
#EndMacro


#Macro LL_Declares(Typ,Daten,ParDef)
	LL_DeclaresF(Daten ,Typ##Daten ,ParDef )
#EndMacro


#Macro LL_FunctionsF(Grundtyp,Datentyp,TypName,Parameter,ParDef)

Property TypName##.##Grundtyp(index As Integer) As Datentyp Ptr
	Dim TempAnzahl As Integer
	Dim ElementA As Datentyp Ptr
	Dim q As Integer
	TempAnzahl = this.##Grundtyp##Count()
	If index < 0 Or index >= TempAnzahl Then Return 0
	ElementA = this.__##Grundtyp
	For q = 1 To index
		ElementA = ElementA->__next
	Next
	Return ElementA
End Property

Function TypName##.##Grundtyp##Count() As Integer
	Dim Zaehler As Integer = 0
	Dim ElementA As Datentyp Ptr
	If this.__##Grundtyp = 0 Then Return Zaehler
	ElementA = this.__##Grundtyp
	Do
		Zaehler += 1
		If ElementA->__next=0 Then Return Zaehler
		ElementA = ElementA->__next
	Loop
End Function

Function TypName##.##Grundtyp##Add ParDef As Integer
	Dim TempAnzahl As Integer
	Dim ElementA As Datentyp Ptr
	Dim ElementB As Datentyp Ptr
	Dim q As Integer
	Dim tmpIndex As Integer
	TempAnzahl = this.##Grundtyp##Count()
	ElementA = New Datentyp Parameter
	If TempAnzahl = 0 Then
		this.__##Grundtyp = ElementA
		ElementA->__next = 0
		Return 0
	Else
		If index < 0 Or index > TempAnzahl Then tmpIndex = TempAnzahl Else tmpIndex = index
		ElementB = this.__##Grundtyp
		For q = 1 To tmpIndex-1
			ElementB = ElementB->__next
		Next
		If tmpIndex = 0 Then
			ElementA->__next = this.__##Grundtyp
			this.__##Grundtyp = ElementA
		Else
			ElementA->__next = ElementB->__next
			ElementB->__next = ElementA
		EndIf
	EndIf
	Return 0
End Function

Function TypName##.##Grundtyp##Remove(index As Integer = -1) As Integer
	Dim TempAnzahl As Integer
	Dim ElementA As Datentyp Ptr
	Dim ElementB As Datentyp Ptr
	Dim tmpIndex As Integer
	Dim q As Integer
	TempAnzahl = this.##Grundtyp##Count()
	If TempAnzahl = 0 Then Return 0
	If index = 0 Then
		ElementA = this.__##Grundtyp
		this.__##Grundtyp = ElementA->__next
		Delete(ElementA)
		Return 0
	EndIf
	If index < 0 Or index >= TempAnzahl Then tmpIndex = TempAnzahl-1 Else tmpIndex = index
	ElementA = this.__##Grundtyp
	For q = 1 To tmpIndex
		ElementB = ElementA
		ElementA = ElementA->__next
	Next
	ElementB->__next = ElementA->__next
	Delete(ElementA)
	Return 0
End Function

Function TypName##.##Grundtyp##Clear() As Integer
	Dim ElementA As Datentyp Ptr
	Dim ElementB As Datentyp Ptr
	If this.__##Grundtyp = 0 Then Return 0
	ElementA = this.__##Grundtyp
	this.__##Grundtyp = 0
	Do
		ElementB = ElementA->__next
		Delete(ElementA)
		If ElementB = 0 Then Exit Do
		ElementA = ElementB
	Loop
	Return 0
End Function

#EndMacro


#Macro LL_Functions(Typ,Daten,Parameter,ParDef)
LL_FunctionsF(Daten ,Typ##Daten ,Typ ,Parameter ,ParDef )
#EndMacro


'=============================================================================
'													Allgemeine Typendeklarationen
'=============================================================================

Type Bruch
	
	Zaehler as Integer
	Nenner as Integer
	
	'declare operator let(value as Integer)
	'declare operator cast() as Double
	
	'declare constructor()
	'declare constructor(Zaehler__ as Integer)
	'declare constructor(Zaehler__ as Integer, Nenner__ as Integer)
	'FBedit Bug
	
End Type

'operator Bruch.let(value as Integer)
'	this.Zaehler = value
'	this.Nenner = 1
'End Operator
'
'operator Bruch.cast() as Double
'	return cast(Double, this.Zaehler) / this.Nenner
'End Operator
'
'constructor Bruch()
'	this.Zaehler = 0
'	this.Nenner = 1
'End Constructor
'
'constructor Bruch(Zaehler__ as Integer)
'	this.Zaehler = Zaehler__
'	this.Nenner = 1
'	
'End Constructor
'
'constructor Bruch(Zaehler__ as Integer, Nenner__ as Integer)
'	this.Zaehler = Zaehler__
'	this.Nenner = Nenner__
'End Constructor



'=============================================================================
'														Allgemeine Funktionen
'=============================================================================

Dim Shared Zeichenkodierung As Integer = 0

Declare Function LPad OverLoad (Daten As String, PadZeichen As String, Laenge As Integer) As String
Declare Function LPad(Daten As String, PadZeichen As Integer, Laenge As Integer) As String

Declare Function RPad OverLoad (Daten As String, PadZeichen As String, Laenge As Integer) As String
Declare Function RPad(Daten As String, PadZeichen As Integer, Laenge As Integer) As String

Declare Function NullString(ByRef tmpStr As String) As String
Declare Function Str2Int(ByRef tmpStr As String, ByVal ByteAOG As UByte = 0) As UInteger
Declare Function Str2IntBE(ByRef tmpStr As String) As UInteger
Declare Function Str2IntLE(ByRef tmpStr As String) As UInteger
Declare Function Str2LongInt(ByRef tmpStr As String, ByVal ByteAOG As UByte = 0) As ULongInt
Declare Function Str2LongIntBE(ByRef tmpStr As String) As ULongInt
Declare Function Str2LongIntLE(ByRef tmpStr As String) As ULongInt
Declare Function Int2Str(ByVal tmpInt As UInteger, ByVal Laenge As Integer = 0, ByVal ByteAOG As UByte = 0) As String
Declare Function Int2StrBE(ByVal tmpInt As UInteger, ByVal Laenge As Integer = 0) As String
Declare Function Int2StrLE(ByVal tmpInt As UInteger, ByVal Laenge As Integer = 0) As String
Declare Function LongInt2Str(ByVal tmpInt As ULongInt, ByVal Laenge As Integer = 0, ByVal ByteAOG As UByte = 0) As String
Declare Function LongInt2StrBE(ByVal tmpInt As ULongInt, ByVal Laenge As Integer = 0) As String
Declare Function LongInt2StrLE(ByVal tmpInt As ULongInt, ByVal Laenge As Integer = 0) As String
Declare Function Synchsafe2Int(ByRef tmpStr As String) As UInteger
Declare Function Int2Synchsafe(ByVal tmpInt As UInteger, ByVal Laenge As Integer = 0) As String
Declare Function Unsynch(ByRef tmpStr As String) As UInteger
Declare Function DeSynch(ByRef tmpStr As String) As UInteger
Declare Function StrRev (ByRef tmpStr As String) As String
Declare Function GetSynch(ByVal DateiNr As Integer, ByVal Laenge As UInteger, ByRef tmpStr As String) As Integer
Declare Function GetOGG (ByVal DateiNr As Integer, ByVal Laenge As UInteger, ByVal NeueOGGPos As Integer = -1) As String
Declare Function InStrRev2(ByRef searchstr As String, ByRef searchpat As String, ByVal startpos As UInteger = 0) As UInteger
Declare Function Bin2GUID(ByRef BinDat As String) As String
Declare Function CmpGUID(ByRef GUID1 As String, ByRef GUID2 As String) As Integer
Declare Function StrAsWStr(ByRef tmpStr As String) As WString Ptr
Declare Function ReplaceAll(ByRef Daten As String, ByVal Suchmuster As String, ByVal Ersatz As String) As String


Declare Function GetTempFile OverLoad () As String
Declare Function GetTempFile(ByRef file As String) As String

Declare Function WriteInFile (daten As String, file As String) As Integer

Declare Function UTF16toUTF8 (Daten As String) As String
Declare Function UFT16toANSI (Daten As String) As String
Declare Function UTF8toUTF16 (Daten As String) As String
Declare Function UTF8toANSI  (Daten As String) As String
Declare Function ANSItoUTF8  (Daten As String) As String
Declare Function ANSItoUTF16 (Daten As String) As String
Declare Function UTF16toAkt  (Daten As String) As String
Declare Function UTF8toAkt   (Daten As String) As String
Declare Function ANSItoAkt   (Daten As String) As String
Declare Function AkttoUTF16  (Daten As String) As String
Declare Function AkttoUTF8   (Daten As String) As String
Declare Function AkttoANSI   (Daten As String) As String


Extern "windows" Lib "kernel32"
#Ifdef UNICODE
Declare Function ReplaceFile Alias "ReplaceFileW" (lpReplacedFileName As LPCTSTR,lpReplacementFileName As LPCTSTR,lpBackupFileName As LPCTSTR,dwReplaceFlags As DWORD, lpExclude As LPVOID,lpReserved As LPVOID) As BOOL
#Else
Declare Function ReplaceFile Alias "ReplaceFileA" (lpReplacedFileName As LPCTSTR,lpReplacementFileName As LPCTSTR,lpBackupFileName As LPCTSTR,dwReplaceFlags As DWORD, lpExclude As LPVOID,lpReserved As LPVOID) As BOOL
#EndIf
End Extern

Function LPad(Daten As String, PadZeichen As String, Laenge As Integer) As String
	Return LPad(Daten, Asc(PadZeichen), Laenge)
End Function

Function LPad(Daten As String, PadZeichen As Integer, Laenge As Integer) As String
	If Len(Daten) = Laenge Then Return Daten
	If Len(Daten) > Laenge Then Return Left(Daten, Laenge)
	Return Daten & String(Laenge - Len(Daten), PadZeichen)
End Function

Function RPad(Daten As String, PadZeichen As String, Laenge As Integer) As String
	Return RPad(Daten, Asc(PadZeichen), Laenge)
End Function

Function RPad(Daten As String, PadZeichen As Integer, Laenge As Integer) As String
	If Len(Daten) = Laenge Then Return Daten
	If Len(Daten) > Laenge Then Return Left(Daten, Laenge)
	Return String(Laenge - Len(Daten), PadZeichen) & Daten
End Function

Function GetOGG (ByVal DateiNr As Integer, ByVal Laenge As UInteger, ByVal NeueOGGPos As Integer = -1) As String
    Static OGGPos As Integer
    Static OGGLaenge As Integer
    Dim e As String = ""
    Dim f As String = ""
    Dim q As UInteger = 0
    If NeueOGGPos >= 0 Then OGGPos = NeueOGGPos: OGGLaenge = 0
    
    Do
        If OGGLaenge-OGGPos = 0 Then
            e = Space(27)
            Get #DateiNr,,e
            'if left(e,4)="OggS" then print "+ OGG-Seite"
            'print " - Version: ";asc(mid(e,5,1))
            'q = asc(mid(e,6,1))
            'if (q AND &B00000001) then print " - Beginn eines neuen Pakets" else print " - Fortsetzung eines alten Pakets"
            'if (q AND &B00000010) then print " - Erster Abschnitt des Bit-Streams"
            'if (q AND &B00000100) then print " - Letzter Abschnitt des Bit-Streams"
            'print " - absolute granule position: "; Str2LongInt(StrRev(mid(e,7,8)))
            'print " - Seriennummer: "; Str2Int(StrRev(mid(e,15,4)))
            'print " - Seitennummer: "; Str2Int(StrRev(mid(e,19,4)))
            'print " - Prfsumme: "; Str2Int(StrRev(mid(e,23,4)))
            'print " - Page Segments: "; asc(mid(e,27,1))
            e = Space(e[26])
            Get #DateiNr,,e
            OGGLaenge = 0
            For q = 1 To Len(e)
                'print "   - Packet lacing: ";asc(mid(e,q,1))
                OGGLaenge += e[q-1]
            Next
            OGGPos = 0
        ElseIf Laenge <= OGGLaenge-OGGPos Then
            e = Space(Laenge)
            Get #DateiNr,,e
            OGGPos += Laenge
            f += e
            Return f
        ElseIf Laenge > OGGLaenge-OGGPos Then
            e = Space(OGGLaenge-OGGPos)
            Get #DateiNr,,e
            Laenge -= OGGLaenge-OGGPos
            OGGPos = OGGLaenge
            f += e
        End If
    Loop
End Function

Function NullString (ByRef tmpStr As String) As String
    Dim NullPos As Integer
    NullPos = InStr(tmpStr, Chr(0))
    'NullPos = InStrRev2(tmpStr, chr(0))
    If NullPos = 0 Then
        Return tmpStr
    Else
        Return Left(tmpStr, NullPos-1)
    End If
End Function

Function Str2Int(ByRef tmpStr As String, ByVal ByteAOG As UByte = 0) As UInteger
  If ByteAOG = 0 Then
  	Return Str2IntBE(tmpStr)
  ElseIf ByteAOG = 1 Then
  	Return Str2IntLE(tmpStr)
  Else
  	Return 0
  End If
End Function

Function Str2IntBE(ByRef tmpStr As String) As UInteger
    Dim q As UInteger
    Dim w As UInteger = 0
    Dim l As Integer = Len(tmpStr)
    For q = 1 To l
        w = w Or (tmpStr[q-1] Shl (l-q)*8)
    Next
    Return w
End Function

Function Str2IntLE(ByRef tmpStr As String) As UInteger
    Dim q As UInteger
    Dim w As UInteger = 0
    Dim l As Integer = Len(tmpStr)
    For q = 1 To l
        w = w Or (tmpStr[q-1] Shl (q-1)*8)
    Next
    Return w
End Function

Function Str2LongInt(ByRef tmpStr As String, ByVal ByteAOG As UByte = 0) As ULongInt
	If ByteAOG = 0 Then
		Return Str2LongIntBE(tmpStr)
	ElseIf ByteAOG = 1 Then
		Return Str2LongIntLE(tmpStr)
	Else
		Return 0
	EndIf
End Function

Function Str2LongIntBE(ByRef tmpStr As String) As ULongInt
    Dim q As ULongInt 'uLongInt, damit kein berlauf bei shl
    Dim w As ULongInt = 0
    Dim l As Integer = Len(tmpStr)
    For q = 1 To l
        w = w Or (tmpStr[q-1] Shl (l-q)*8)
    Next
    Return w
End Function

Function Str2LongIntLE(ByRef tmpStr As String) As ULongInt
    Dim q As ULongInt 'uLongInt, damit kein berlauf bei shl
    Dim w As ULongInt = 0
    Dim l As Integer = Len(tmpStr)
    For q = 1 To l
        w = w Or (tmpStr[q-1] Shl (q-1)*8)
    Next
    Return w
End Function

Function Int2Str(ByVal tmpInt As UInteger, ByVal Laenge As Integer = 0, ByVal ByteAOG As UByte = 0) As String
	If ByteAOG = 0 Then
		Return Int2StrBE(tmpInt, Laenge)
	ElseIf ByteAOG = 1 Then
		Return Int2StrLE(tmpInt, Laenge)
	Else
		Return ""
	EndIf
End Function

Function Int2StrBE(ByVal tmpInt As UInteger, ByVal Laenge As Integer = 0) As String
	Dim q As Integer = 0
	Dim tmpStr As String = ""
	Do
		tmpStr = Chr((tmpInt Shr q*8) And &b11111111) + tmpStr
		q += 1
		If (tmpInt Shr (q*8)) = 0 Then Exit Do
	Loop
	If Laenge > 0 Then tmpStr = RPad(tmpStr,0,Laenge)
	Return tmpStr
End Function

Function Int2StrLE(ByVal tmpInt As UInteger, ByVal Laenge As Integer = 0) As String
	Dim q As Integer = 0
	Dim tmpStr As String = ""
	Do
		tmpStr += Chr((tmpInt Shr q*8) And &b11111111)
		q += 1
		If (tmpInt Shr (q*8)) = 0 Then Exit Do
	Loop
	If Laenge > 0 Then tmpStr = LPad(tmpStr,0,Laenge)
	Return tmpStr
End Function

Function Synchsafe2Int(ByRef tmpStr As String) As UInteger
    Dim q As Integer
    Dim w As UInteger = 0
    Dim l As Integer = Len(tmpStr)
    For q = 1 To l
        w = w Or (tmpStr[q-1] Shl (l-q)*7)
    Next
    Return w
End Function

Function Int2Synchsafe(ByVal tmpInt As UInteger, ByVal Laenge As Integer = 0) As String
	Dim q As Integer = 0
	Dim tmpStr As String = ""
	Do
		tmpStr = Chr((tmpInt Shr q*7) And &b01111111) + tmpStr
		If (tmpInt Shr ((q+1)*7)) = 0 Then Exit Do
		q += 1
	Loop
	If Laenge > 0 Then tmpStr = RPad(tmpStr,0,Laenge)
	Return tmpStr
End Function

Function Unsynch(ByRef tmpStr As String) As UInteger
    Dim q As Integer = 0
    Dim w As UInteger = 0
    Do
        q = InStr(q+1,tmpStr,Chr(&HFF))
        'if q >= len(tmpStr) then exit do
        If q = 0 Then Exit Do
        If ((tmpStr[q] And &B11100000) = &B11100000) OrElse (tmpStr[q] = 0) Then tmpStr = Left(tmpStr,q)+Chr(0)+Mid(tmpStr,q+1):q += 0: w += 1
    Loop
    Return w
End Function

Function DeSynch(ByRef tmpStr As String) As UInteger
    Dim q As Integer = 0
    Dim w As UInteger = 0
    Do
        q = InStr(q+1,tmpStr,Chr(&HFF, &H00))
        'if q >= (len(tmpStr)-1) then exit do
        If q = 0 Then Exit Do
        If ((tmpStr[q+1] And &B11100000) = &B11100000) OrElse (tmpStr[q+1] = 0) Then tmpStr = Left(tmpStr,q)+Mid(tmpStr,q+2):q += 0: w += 1
    Loop
    Return w
End Function

Function GetSynch(ByVal DateiNr As Integer, ByVal Laenge As UInteger, ByRef tmpStr As String) As Integer
	Dim q As UInteger = 0
	Dim Synchs As UInteger = 0
	Dim SynchsNeu As UInteger = 0
	Dim SynchPos As UInteger = 0
	Dim LastSynchPos As UInteger = 0
	Dim LastPos As UInteger = 1
	Dim Position As ULongInt = Seek(DateiNr)
	Dim TagDaten As String = ""
	tmpStr = ""
	
	If Laenge = 0 Then Return 0
	
	Do
		If LastPos = 1 Then TagDaten = Space(Laenge+1) Else TagDaten = Space(SynchsNeu)
		Get #DateiNr,,TagDaten
		tmpStr += TagDaten
		SynchsNeu = 0
		SynchPos = LastPos
		If (Len(tmpStr) >= 2) Then
			Do
				SynchPos = InStr(SynchPos+1,tmpStr,Chr(&HFF,&H00))
				If SynchPos = 0 Then Exit Do
				If SynchPos <> LastSynchPos Then
					LastSynchPos = SynchPos
					tmpStr = Left(tmpStr, SynchPos)+Mid(tmpStr, SynchPos+2)
					SynchsNeu += 1
				EndIf
			Loop
		EndIf
		Synchs += SynchsNeu
		LastPos = Len(tmpStr)-2
		If Len(tmpStr) >= (Laenge+1) Then Exit Do
	Loop
	tmpStr = Left(tmpStr, Len(tmpStr)-1)
	
	Seek #DateiNr,Position+Laenge+Synchs
	Return Synchs
End Function

'FUNKTIONIERT, aber langsam
'function GetSynch(byval DateiNr as integer, byval Laenge as uinteger, byref tmpStr as string) as integer
'	dim Synchs as UInteger = 0
'	dim LastSynchPos as UInteger = 0
'	dim Position as ULongInt = seek(DateiNr)
'	dim TagDaten as String = ""
'	tmpStr = ""
'	
'	if Laenge = 0 then return 0
'
'	do
'		TagDaten = space(1)
'		get #DateiNr,,TagDaten
'		tmpStr += TagDaten
'		if (len(tmpStr) >= 2) and (len(tmpStr) <> LastSynchPos) then
'			if (mid(tmpStr, len(tmpStr)-1,1) = chr(&HFF)) and (mid(tmpStr, len(tmpStr),1) = chr(&H00)) then
'				LastSynchPos = len(tmpStr)
'				tmpStr = left(tmpStr, len(tmpStr)-1)
'				Synchs += 1
'			EndIf
'		EndIf
'		if len(tmpStr) >= (Laenge+1) then exit do
'	Loop
'	tmpStr = left(tmpStr, len(tmpStr)-1)
'	
'	'TagDaten = "Lnge: "+str(Laenge)+", Tatschlich: "+str(len(tmpStr))+", Synchs: "+str(Synchs)
'	'MessageBox(0, strptr(TagDaten),"DEBUG", MB_OK)
'	
'	seek #DateiNr,Position+Laenge+Synchs
'	return Synchs
'end function

Function StrRev (ByRef tmpStr As String) As String
    Dim q As Integer
    Dim e As String
    For q = 1 To Len(tmpStr)
        e = Mid(tmpStr,q,1)+e
    Next
    Return e
End Function

Function InStrRev2(ByRef searchstr As String, ByRef searchpat As String, ByVal startpos As UInteger = 0) As UInteger
    Dim SStrPtr As Integer = CInt(StrPtr(searchstr))
    Dim SPatPtr As Integer = CInt(StrPtr(searchpat))
    Dim SStrLen As Integer = Len(searchstr)
    Dim SPatLen As Integer = Len(searchpat)
    If startpos > 0 Then SStrLen = startpos + SPatLen - 1
    If SStrLen > Len(searchstr) Then SStrLen = Len(searchstr)
    If SPatLen > SStrLen Then Return 0
    Asm
        std                         'Rckwrts suchen
        mov ecx, [SStrLen]          'Lnge des Strings
        mov ebx, [SPatLen]          'Lnge des Suchstrings
        mov edi, [SStrPtr]          'Offset des Strings
        mov esi, [SPatPtr]          'Offset des Suchstrings
        Add edi, ecx                'Ans Ende des Strings springen
        Sub edi, ebx                'Vom Ende die Lnge des Suchstrings zurcksprigen
        mov al,  [esi]              'Erstes Zeichen berprfen
      instrrev_continue:  
        repne scasb
        jz instrrev_foundfirst
        jcxz instrrev_notfound
      instrrev_foundfirst:
        push ecx
        push edi
        mov ecx, ebx
        Add edi, ebx
        mov esi, [SPatPtr]
        Add esi, ebx
        dec esi
        repe cmpsb
        jz instrrev_found
        pop edi
        pop ecx
        jmp instrrev_continue
      instrrev_found:
        pop edi
        pop ecx
        mov edx, edi
        Sub edx, [SStrPtr]
        Add edx, 2
        mov [Function], edx
      instrrev_notfound:
        cld
    End Asm
End Function

Function Bin2GUID(ByRef BinDat As String) As String
    Return Hex(Str2IntLE(Mid(BinDat,1,4)),8) & "-" & Hex(Str2IntLE(Mid(BinDat,5,2)),4) & "-" & Hex(Str2IntLE(Mid(BinDat,7,2)),4) & "-" & Hex(Str2IntBE(Mid(BinDat,9,2)),4) & "-" & Hex(Str2LongIntBE(Mid(BinDat,11,6)),12)
End Function

Function CmpGUID(ByRef GUID1 As String, ByRef GUID2 As String) As Integer
    Dim tmp1 As String
    Dim tmp2 As String
    If Len(GUID1) = 16 Then
        tmp1 = Bin2GUID(GUID1)
    ElseIf Len(GUID1) = 36 Then
        tmp1 = GUID1
    Else
        Return 0
    End If
    If Len(GUID2) = 16 Then
        tmp2 = Bin2GUID(GUID2)
    ElseIf Len(GUID2) = 36 Then
        tmp2 = GUID2
    Else
        Return 0
    End If
    If tmp1=tmp2 Then Return -1 Else Return 0
End Function

Function StrAsWStr(ByRef tmpStr As String) As WString Ptr
    Dim tmp As WString Ptr = Allocate( Len(tmpStr) * Len(WString) )
    Dim SStrOff As UInteger = CInt(StrPtr(tmpStr))
    Dim DStrOff As UInteger = CInt(StrPtr(*tmp))
    Dim StrLen As UInteger = Len(tmpStr)
    Asm
        mov esi, [SStrOff]
        mov edi, [DStrOff]
        mov ecx, [StrLen]
        cld
        repnz movsb
    End Asm
    Return tmp
End Function

Function GetTempFile() As String
	Return GetTempFile("")
End Function

Function GetTempFile(file As String) As String
	Dim q As Integer
	Dim w As Integer
	Dim DateiName As String
	Dim Datei As String
	Dim DateiExt As String
	Dim Temp As String
	Dim Zufall As Integer
	q=InStrRev2(file, ".")
	If q <> 0 Then
		Datei = Left(file, q-1)
		DateiExt = Mid(file, q)
	Else
		Datei = file
		DateiExt = ".tmp"
	EndIf
	If Datei = "" Then
		Datei = "~TMP_"
		DateiExt = ".tmp"
	EndIf
	For q=1 To 1000
		DateiName = Datei
		For q = -2 To CInt(q/15)
			Zufall = Int(Rnd * 26+65)
			DateiName = DateiName & Chr(Zufall)
		Next
		DateiName = DateiName & DateiExt
		If Dir(DateiName) = "" Then Return DateiName
	Next
End Function

Function WriteInFile (daten As String, file As String) As Integer
	Dim TempDatei As String
	Dim hDatei As HANDLE
	Dim Laenge As Integer
	
	TempDatei = GetTempFile(file)
	If CopyFile(StrPtr(file), StrPtr(TempDatei), FALSE) = 0 Then Return 30
	hDatei = CreateFile(file, GENERIC_WRITE, FILE_SHARE_READ, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0)
	If hDatei = 0 Then Kill TempDatei: Return 30
	If WriteFile(hDatei, StrPtr(daten), Len(daten), @Laenge, 0) = 0 Then CloseHandle(hDatei): Kill TempDatei: Return 30
	If Laenge <> Len(daten) Then CloseHandle(hDatei): Kill TempDatei: Return 30
	CloseHandle(hDatei)
	Kill TempDatei
	
	'open file for binary as DateiN
	'if err > 0 then close DateiN: print "sdafsd":return 22
	'put #DateiN, 1, Datei
	'close #DateiN
	'if ReplaceFile(strptr(file), strptr(TempDatei), 0, REPLACEFILE_WRITE_THROUGH, 0, 0) = 0 then
	
	Return 0
End Function

Function ReplaceAll(ByRef Daten As String, ByVal Suchmuster As String, ByVal ErsatzStr As String) As String
	Dim q As Integer = 1
	
	Do
		q=InStr(q, Daten, Suchmuster)
		If q=0 Then Exit Do
		daten = Left(Daten, q-1) & ErsatzStr & Mid(Daten, q+Len(Suchmuster))
		q+=Len(ErsatzStr)
	Loop
	
	Return daten
End Function

