#define CRLF chr(13,10)
#include "D:\Dokumente und Einstellungen\Stefan\Desktop\Projekte\Multimedia-Tag\Multimedia-Tag 0.9.3 General.bas"

Dim XMLDaten as String

open "testdat.xml" for binary as #1
XMLDaten = space(lof(1))
get #1,1,XMLDaten
close #1


Type XML
	Tag as String
	Flags as UInteger = 0
	Daten as String
	SubTags as String = ""
	Parent as XML ptr
	Declare Function GetSubTag(ElemNr as Integer, Flag as UInteger = 0) as XML ptr
	Declare Function GetSubTag(Tag as String, ElemNr as Integer = 0, Flag as UInteger = 0) as XML ptr
	Declare Function SubTagCount(Flag as UInteger = 0) as Integer
	Declare Function SubTagAdd(Tag__ as String = "", Daten__ as String = "", Flags__ as UInteger = 0) as Integer
	Declare Function SubTagRemove(ElemNr as Integer, Flag as UInteger = 0) as Integer
	Declare Function SubTagRemove(Tag as String, ElemNr as Integer = 0, Flag as UInteger = 0) as Integer
	Declare Function SubTagClear(Flag as UInteger = 0) as Integer
	Declare Function SubTagChPos(SubXML as XML ptr, ElemPos as Integer, Flag as UInteger = 0) as Integer
	Declare Function SubTagCountElem(Tag as String, Flag as UInteger = 0) as Integer
	Declare Function GetIndexOf(SubXML as XML ptr, Flag as UInteger = 0) as Integer
	Declare Function ChPos(ElemPos as Integer, Flag as UInteger = 0) as Integer
	Declare Function Parse(XMLDaten as String) as Integer
	Declare Function ToString(Level as Integer = 0) as String
	Declare Destructor()
End Type


Function XML.Parse(XMLDaten as String) as Integer
	Dim q as Integer
	Dim SPos as UInteger
	Dim TPos as UInteger
	Dim EPos as UInteger
	Dim FPos as UInteger
	Dim tmpDaten as String
	Dim tmpStr as String
	Dim Trennzeichen as String
	Dim SubXML as XML ptr
	
	if Subtags <> "" then SubTagClear()
	
	this.Tag = ""
	this.Flags = 1
	this.Daten = ""
	this.SubTags = ""
	
	SPos = Instr(XMLDaten, "<")
	if SPos = 0 then return 0
	EPos = Instr(SPos+1, XMLDaten, " ")
	TPos = Instr(SPos+1, XMLDaten, chr(10))
	if (TPos < EPos and TPos <> 0) or EPos = 0 then EPos = TPos
	TPos = Instr(SPos+1, XMLDaten, chr(13))
	if (TPos < EPos and TPos <> 0) or EPos = 0 then EPos = TPos
	TPos = Instr(SPos+1, XMLDaten, "/>")
	if (TPos < EPos and TPos <> 0) or EPos = 0 then EPos = TPos
	TPos = Instr(SPos+1, XMLDaten, ">")
	if (TPos < EPos and TPos <> 0) or EPos = 0 then EPos = TPos
	this.Tag = mid(XMLDaten, SPos+1, EPos-SPos-1)
	if EPos <> TPos then
		SPos = Instr(EPos+1, XMLDaten, ">")
		if mid(XMLDaten, SPos-1, 2) = "/>" then tmpDaten = mid(XMLDaten, EPos+1, SPos-EPos-2) else tmpDaten = mid(XMLDaten, EPos+1, SPos-EPos-1)
		do
			EPos = Instr(tmpDaten, "=")
			if EPos = 0 then exit do
			FPos = Instr(EPos+1, tmpDaten, "'")
			TPos = Instr(EPos+1, tmpDaten, !"\"")
			if (TPos < FPos and TPos <> 0) or FPos = 0 then FPos = TPos
			Trennzeichen = mid(tmpDaten, FPos, 1)
			TPos = Instr(FPos+1, tmpDaten, Trennzeichen)
			this.SubTagAdd(trim(left(tmpDaten, EPos-1), Any chr(32, 13, 10, 9)), mid(tmpDaten, FPos+1, TPos-FPos-1), 2)
			tmpDaten = mid(tmpDaten, TPos+2)
		Loop
	else
		SPos = EPos
	EndIf
	if mid(XMLDaten, SPos-1, 2) = "/>" then return 0
	EPos = SPos
	Do
		SPos = Instr(SPos+1, XMLDaten, "<")
		if SPos = 0 or mid(XMLDaten, SPos+1, 1) = "/" then
			if len(this.SubTags) = this.SubTagCount(2)*4 then
				SPos = Instr(EPos+1, XMLDaten, "</"+this.Tag+">")
				this.Daten = mid(XMLDaten, EPos+1, SPos-EPos-1)
			EndIf
			exit do
		EndIf
		FPos = SPos
		EPos = Instr(SPos+1, XMLDaten, " ")
		TPos = Instr(SPos+1, XMLDaten, ">")
		if (TPos < EPos and TPos <> 0) or EPos = 0 then EPos = TPos
		TPos = Instr(SPos+1, XMLDaten, chr(10))
		if (TPos < EPos and TPos <> 0) or EPos = 0 then EPos = TPos
		TPos = Instr(SPos+1, XMLDaten, chr(13))
		if (TPos < EPos and TPos <> 0) or EPos = 0 then EPos = TPos
		TPos = Instr(SPos+1, XMLDaten, "/>")
		if (TPos < EPos and TPos <> 0) or EPos = 0 then EPos = TPos
		tmpDaten = mid(XMLDaten, SPos+1, EPos-SPos-1)
		SPos = Instr(EPos+1, XMLDaten, "</"+tmpDaten+">")
		TPos = Instr(EPos+1, XMLDaten, "/>")
		if SPos = 0 then SPos = TPos+1 else SPos += 2+Len(tmpDaten)
		tmpDaten = mid(XMLDaten, FPos, SPos-FPos+1)
		SubXML = New XML
		if SubXML = 0 then return 10
		SubXML->Parent = @this
		this.SubTags &= Int2StrLE(cast(UInteger, SubXML), 4)
		q = SubXML->Parse(tmpDaten)
		if q <> 0 then return q
	Loop
	
	return 0
End Function

Destructor XML()
	if Subtags <> "" then SubTagClear()
End Destructor

Function XML.ToString(Level as Integer = 0) as String
	dim tmpDaten as String = ""
	dim SubXML as XML ptr
	tmpDaten = String(Level, 9) & "<" & this.Tag
	for q as Integer = 0 to this.SubTagCount(2)-1
		tmpDaten &= " " & GetSubTag(q, 2)->Tag & !"=\"" & GetSubTag(q, 2)->Daten & !"\""
	Next
	if this.Daten <> "" then
		tmpDaten &= ">" & this.Daten
	else
		if this.SubTagCount(1) = 0 then return tmpDaten & "/>" & CRLF
		tmpDaten &= ">" & CRLF
		for q as Integer = 0 to this.SubTagCount(1)-1
			tmpDaten &= this.GetSubTag(q,1)->ToString(Level+1)
		Next
		tmpDaten &= String(Level, 9)
	EndIf
	tmpDaten &= "</" & this.Tag & ">" & CRLF
	return tmpDaten
End Function

Function XML.SubTagCount(Flag as UInteger = 0) as Integer
	if Flag = 0 then return len(this.SubTags)/4
	Dim Anz as Integer = 0
	For q as Integer = 0 to len(this.SubTags)/4-1
		if (Cast(XML ptr, Str2IntLE(mid(this.SubTags, q*4+1, 4)))->Flags and Flag) <> 0 then Anz += 1
	Next
	return Anz
End Function

Function XML.GetSubTag(ElemNr as Integer, Flag as UInteger = 0) as XML ptr
	if ElemNr >= this.SubTagCount(Flag) or ElemNr < 0 then return 0
	if Flag = 0 then return Cast(XML ptr, Str2IntLE(mid(this.SubTags, ElemNr*4+1, 4)))
	Dim Anz as Integer = 0
	Dim SubXML as XML ptr
	For q as Integer = 0 to (len(this.SubTags)/4)-1
		SubXML = Cast(XML ptr, Str2IntLE(mid(this.SubTags, q*4+1, 4)))
		if (SubXML->Flags and Flag) <> 0 then Anz += 1
		if ElemNr+1 = Anz then return SubXML
	Next
End Function

Function XML.GetSubTag(Tag as String, ElemNr as Integer = 0, Flag as UInteger = 0) as XML ptr
	dim Anz as Integer = 0
	dim SubXML as XML ptr
	for q as Integer = 0 to (len(this.SubTags)/4)-1
		SubXML = Cast(XML ptr, Str2IntLE(mid(this.SubTags, q*4+1, 4)))
		if (SubXML->Tag = Tag) and ((Flag = 0) OrElse ((SubXML->Flags and Flag) <> 0)) then Anz += 1
		if ElemNr+1 = Anz then return SubXML
	Next
	return 0
End Function

Function XML.SubTagAdd(Tag__ as String = "", Daten__ as String = "", Flags__ as UInteger = 0) as Integer
	Dim SubXML as XML ptr
	if (Flags__ and 2) <> 2 then this.Daten = ""
	SubXML = New XML
	if SubXML = 0 then return 10
	this.SubTags &= Int2StrLE(cast(UInteger, SubXML), 4)
	SubXML->Parent = @this
	SubXML->Tag = Tag__
	SubXML->Daten = Daten__
	SubXML->Flags = IIf(Flags__ = 0, 1, Flags__)
	'FBedit Bug
	return 0
End Function

Function XML.SubTagRemove(ElemNr as Integer, Flag as UInteger = 0) as Integer
	if ElemNr >= this.SubTagCount(Flag) or ElemNr < 0 then return 0
	if Flag = 0 then
		Delete(Cast(XML ptr, Str2IntLE(mid(this.SubTags, ElemNr*4+1, 4))))
		this.SubTags = left(this.SubTags, ElemNr*4) & mid(this.SubTags, (ElemNr+1)*4+1)
		return 0
	EndIf
	Dim Anz as Integer = 0
	Dim SubXML as XML ptr
	For q as Integer = 0 to (len(this.SubTags)/4)-1
		SubXML = Cast(XML ptr, Str2IntLE(mid(this.SubTags, q*4+1, 4)))
		if (SubXML->Flags and Flag) <> 0 then Anz += 1
		if ElemNr+1 = Anz then
			Delete(SubXML)
			this.SubTags = left(this.SubTags, q*4) & mid(this.SubTags, (q+1)*4+1)
			return 0
		EndIf
	Next
	return 0
End Function

Function XML.SubTagRemove(Tag as String, ElemNr as Integer = 0, Flag as UInteger = 0) as Integer
	if ElemNr >= this.SubTagCount(Flag) or ElemNr < 0 then return 0
	Dim Anz as Integer = 0
	Dim SubXML as XML ptr
	For q as Integer = 0 to (len(this.SubTags)/4)-1
		SubXML = Cast(XML ptr, Str2IntLE(mid(this.SubTags, q*4+1, 4)))
		if (SubXML->Tag = Tag) and ((Flag = 0) OrElse ((SubXML->Flags and Flag) <> 0)) then Anz += 1
		if ElemNr+1 = Anz then
			Delete(SubXML)
			this.SubTags = left(this.SubTags, q*4) & mid(this.SubTags, (q+1)*4+1)
			return 0
		EndIf
	Next
	return 0
End Function

Function XML.SubTagClear(Flag as UInteger = 0) as Integer
	Dim SubXML as XML ptr
	for q as Integer = (len(this.SubTags)/4)-1 to 0 step -1
		SubXML = Cast(XML ptr, Str2IntLE(mid(this.SubTags, q*4+1, 4)))
		if (Flag = 0) OrElse ((SubXML->Flags and Flag) <> 0) then
			Delete(SubXML)
			this.SubTags = left(this.SubTags, q*4) & mid(this.SubTags, (q+1)*4+1)
		EndIf
	Next
	return 0
End Function

Function XML.GetIndexOf(SubXML as XML ptr, Flag as UInteger = 0) as Integer
	Dim Anz as Integer = 0
	Dim TmpXML as XML ptr
	For q as Integer = 0 to (len(this.SubTags)/4)-1
		TmpXML = Cast(XML ptr, Str2IntLE(mid(this.SubTags, q*4+1, 4)))
		if Flag = 0 OrElse (TmpXML->Flags and Flag) <> 0 then
			if TmpXML = SubXML then return Anz
			Anz += 1
		EndIf
	Next
	return -1
End Function

Function XML.SubTagChPos(SubXML as XML ptr, ElemPos as Integer, Flag as UInteger = 0) as Integer
	Dim Anz as Integer = 0
	Dim tmpPos as Integer = ElemPos
	if SubXML = 0 then return 1
	if tmpPos < 0 then tmpPos = 0
	if tmpPos > len(this.SubTags)/4 then tmpPos = len(this.SubTags)/4
	for q as Integer = 0 to len(this.SubTags)/4
		if q = len(this.SubTags)/4 then return 15
		if (Cast(XML ptr, Str2IntLE(mid(this.SubTags, q*4+1, 4))) = SubXML) and (Flag = 0 OrElse ((Cast(XML ptr, Str2IntLE(mid(this.SubTags, q*4+1, 4)))->Flags and Flag) <> 0)) then
			this.SubTags = left(this.SubTags, q*4) & mid(this.SubTags, (q+1)*4+1)
			exit for
		EndIf
	Next
	for q as Integer = 0 to len(this.SubTags)/4
		if ElemPos = Anz then
			this.SubTags = left(this.SubTags, q*4) & Int2StrLE(cast(UInteger,SubXML),4) & mid(this.SubTags, q*4+1)
			return 0
		EndIf
		if q = len(this.SubTags)/4 then return 1
		if Flag = 0 OrElse (Cast(XML ptr, Str2IntLE(mid(this.SubTags, q*4+1, 4)))->Flags and Flag) <> 0 then Anz += 1
	Next
End Function

Function XML.ChPos(ElemPos as Integer, Flag as UInteger = 0) as Integer
	return this.Parent->SubTagChPos(@this, ElemPos, Flag)
End Function

Function XML.SubTagCountElem(Tag as String, Flag as UInteger = 0) as Integer
	Dim Anz as Integer = 0
	Dim SubXML as XML ptr
	For q as Integer = 0 to (len(this.SubTags)/4)-1
		SubXML = Cast(XML ptr, Str2IntLE(mid(this.SubTags, q*4+1, 4)))
		if SubXML->Tag = Tag and (Flag = 0 OrElse (SubXML->Flags and Flag) <> 0) then Anz += 1
	Next
	return Anz
End Function

Dim shared test as XML


Function getRDFElem(ElemID as String) as XML ptr
	Dim TopXML as XML ptr
	Dim SubXML as XML ptr
	Dim tmpXML as XML ptr
	Dim ElemKat as String
	Dim ElemDat as String
	Dim ns as String
	Dim q as Integer = 0
	if test.Tag = "rdf:RDF" then
		TopXML = @test
	elseif test.Tag = "x:xmpmeta" then
		TopXML = test.GetSubTag("rdf:RDF")
		if TopXML = 0 then return 0
	else
		return 0
	EndIf
	q = Instr(ElemID, ":")
	if q <= 1 then return 0
	ElemKat=left(ElemID, q-1)
	ElemDat=mid(ElemID, q+1)
	select case ElemKat
		case "DICOM": ns = "http://ns.adobe.com/DICOM/"
		case "Iptc4xmpCore": ns = "http://ns.microsoft.com/photo/1.0"
		case "dc": ns = "http://purl.org/dc/elements/1.1/"
		case "exif": ns = "http://ns.adobe.com/exif/1.0/"
		case "photoshop": ns = "http://ns.adobe.com/photoshop/1.0/"
		case "pdf": ns = "http://ns.adobe.com/pdf/1.3/"
		case "swf": ns = "http://ns.adobe.com/swf/1.0/"
		case "tiff": ns = "http://ns.adobe.com/tiff/1.0/"
		case "aux": ns = "http://ns.adobe.com/exif/1.0/aux/"
		case "xmp": ns = "http://ns.adobe.com/xap/1.0/"
		case "xmpMM": ns = "http://ns.adobe.com/xap/1.0/mm/"
		case "xmpBJ": ns = "http://ns.adobe.com/xap/1.0/bj/"
		case "xmpTPg": ns = "http://ns.adobe.com/xap/1.0/t/pg/"
		case "xmpRights": ns = "http://ns.adobe.com/xap/1.0/rights/"
		case "xmpDM": ns = "http://ns.adobe.com/xmp/1.0/DynamicMedia/"
		case "stEvt": ns = "http://ns.adobe.com/xap/1.0/sType/ResourceEvent#"
		case "crs": ns = "http://ns.adobe.com/camera-raw-settings/1.0/"
		case else: return 0
	End Select
	q = 0
	Do
		SubXML = TopXML->GetSubTag("rdf:Description", q)
		if SubXML = 0 then exit do
		for w as Integer = 0 to SubXML->SubTagCount(2)
			if w = SubXML->SubTagCount(2) then q += 1: continue do
			tmpXML = SubXML->GetSubTag(w, 2)
			if (left(tmpXML->Tag, 6) = "xmlns:") and (tmpXML->Daten = ns) then ns = mid(tmpXML->Tag, 7):exit for
		next
		if SubXML->GetSubTag(ns & ":" & ElemDat) <> 0 then return SubXML->GetSubTag(ns & ":" & ElemDat)
		q += 1
	Loop
	return 0
End Function

Function setRDFElem(ElemID as String) as XML ptr
	Dim TopXML as XML ptr
	Dim SubXML as XML ptr
	Dim SubXMLKat as XML ptr
	Dim tmpXML as XML ptr
	Dim ElemKat as String
	Dim ElemDat as String
	Dim ns as String
	Dim nsn as String = ""
	Dim q as Integer
	
	if ElemID = "" then return 0
	if test.Tag = "rdf:RDF" then
		TopXML = @test
	elseif test.Tag = "x:xmpmeta" then
		TopXML = test.GetSubTag("rdf:RDF")
		if TopXML = 0 then return 0
	else
		return 0
	EndIf
	q = Instr(ElemID, ":")
	if q <= 1 then return 0
	ElemKat=left(ElemID, q-1)
	ElemDat=mid(ElemID, q+1)
	select case ElemKat
		case "DICOM": ns = "http://ns.adobe.com/DICOM/"
		case "Iptc4xmpCore": ns = "http://ns.microsoft.com/photo/1.0"
		case "dc": ns = "http://purl.org/dc/elements/1.1/"
		case "exif": ns = "http://ns.adobe.com/exif/1.0/"
		case "photoshop": ns = "http://ns.adobe.com/photoshop/1.0/"
		case "pdf": ns = "http://ns.adobe.com/pdf/1.3/"
		case "swf": ns = "http://ns.adobe.com/swf/1.0/"
		case "tiff": ns = "http://ns.adobe.com/tiff/1.0/"
		case "aux": ns = "http://ns.adobe.com/exif/1.0/aux/"
		case "xmp": ns = "http://ns.adobe.com/xap/1.0/"
		case "xmpMM": ns = "http://ns.adobe.com/xap/1.0/mm/"
		case "xmpBJ": ns = "http://ns.adobe.com/xap/1.0/bj/"
		case "xmpTPg": ns = "http://ns.adobe.com/xap/1.0/t/pg/"
		case "xmpRights": ns = "http://ns.adobe.com/xap/1.0/rights/"
		case "xmpDM": ns = "http://ns.adobe.com/xmp/1.0/DynamicMedia/"
		case "stEvt": ns = "http://ns.adobe.com/xap/1.0/sType/ResourceEvent#"
		case "crs": ns = "http://ns.adobe.com/camera-raw-settings/1.0/"
		case else: return 0
	End Select
	q = 0
	Do
		SubXML = TopXML->GetSubTag("rdf:Description", q)
		if SubXML = 0 then exit do
		for w as Integer = 0 to SubXML->SubTagCount(2)
			if w = SubXML->SubTagCount(2) then q += 1: continue do
			tmpXML = SubXML->GetSubTag(w, 2)
			if (left(tmpXML->Tag, 6) = "xmlns:") and (tmpXML->Daten = ns) then nsn = mid(tmpXML->Tag, 7):SubXMLKat = SubXML:exit for
		next
		if SubXML->GetSubTag(nsn & ":" & ElemDat) <> 0 then return SubXML->GetSubTag(nsn & ":" & ElemDat)
		'if nsn <> "" and SubXML->GetSubTag("xmlns:" & nsn,,2) <> 0 then SubXMLKat = SubXML
		q += 1
	Loop
	if SubXMLKat = 0 then
		TopXML->SubTagAdd("rdf:Description")
		SubXMLKat = TopXML->GetSubTag(TopXML->SubTagCount()-1)
		SubXMLKat->SubTagAdd("rdf:about",,2)
		SubXMLKat->SubTagAdd("xmlns:" & ElemKat, ns, 2)
		nsn = ElemKat
		SubXMLKat->SubTagAdd(ElemID, "")
	else
		SubXMLKat->SubTagAdd(nsn & ":" & ElemDat, "")
	EndIf
	return SubXMLKat->GetSubTag(nsn & ":" & ElemDat)
End Function

'Dim shared test as XML
Dim StartZ as Double
Dim EndZ as Double

'for q as Integer = 0 to 15  ' max. 0 to 15
'	XMLDaten = XMLDaten & XMLDaten
'Next
print len(XMLDaten); " Bytes groes XML Dokument erzeugt."

StartZ = timer
test.Parse(XMLDaten)
EndZ = timer

print "Zeit bentigt: "; EndZ-StartZ; " s"

'print
'print "Anzahl Gesamt: "; test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SubTagCount(0)
'print "Anzahl Tags: "; test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SubTagCount(1)
'print "Anzahl Attribute: "; test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SubTagCount(2)
'print
'print "Index (1): "; test.GetSubTag("rdf:RDF")->GetIndexOf(test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description"), 0)
'print "Index (0): "; test.GetSubTag("rdf:RDF")->GetIndexOf(test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description"), 1)
'print "Index (-1): "; test.GetSubTag("rdf:RDF")->GetIndexOf(test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description"), 2)
'print
'
''test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SubTagClear(2)
''test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SubTagClear(1)
''test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SubTagClear(0)
'
'print test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->GetSubTag(2, 2)->Tag
'print test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->GetSubTag(2, 1)->Tag
'print test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->GetSubTag(2, 0)->Tag
'print test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->GetSubTag("xmlns:Iptc4xmpCore")->Tag
'print test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->GetSubTag("xmlns:Iptc4xmpCore", 1)
'print test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->GetSubTag("xmlns:Iptc4xmpCore", 0)->Tag
''print test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->GetSubTag(2, 2)->Tag
'
''test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SubTagRemove(0,2)
''test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SubTagRemove(0,1)
'
'test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SubTagAdd("Hallo", "Stefan")
'test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SubTagAdd("Hallo", "Wurzinger", 2)
'test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SubTagRemove("Hallo", 0, 2)
''test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SubTagRemove("Hallo", 0, 1)
'
'test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SubTagChPos(test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->GetSubTag("Hallo", 0, 1), 14, 0)
'
'print "Anz(4): "; test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->GetSubTag("dc:subject")->GetSubTag("rdf:Bag")->SubTagCountElem("rdf:li", 1)
'
print
print

print getRDFElem("xmp:Rating")
print getRDFElem("xmp:Rating")->Daten
print setRDFElem("xmp:Test123")
setRDFElem("xmp:Test123")->Daten = "Hallo123"
setRDFElem("xmpBJ:ATNftw")->Daten = "SteveIsGreat"

'test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SetAttr("rdf:about", "XML mit FreeBasic")
'test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->SetAttr(0, "XML mit FreeBasic")
'test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->AttrAdd("MyXMLAttribNo01", "Erstellt mit XML fuer FreeBasic")
'if test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->AttrExist("MyXMLAttribNo01") then print "Attribut erfolgreich erstellt!" else print "Fehler beim Erstellen des Attributs"
'print "Wert: "; test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->GetAttr("MyXMLAttribNo01")
'test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->AttrRename(2, "MyXML01")
'if test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->AttrExist("MyXML01") then print "Attribut erfolgreich umbenannt!" else print "Fehler beim Umbenennen des Attributs"
'test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->AttrRename("MyXML01", "MyAttrib01")
'if test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->AttrExist("MyAttrib01") then print "Attribut erfolgreich umbenannt!" else print "Fehler beim Umbenennen des Attributs"
'print "Wert: "; test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->GetAttr("MyAttrib01")
'test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->AttrRemove("MyAttrib01")
'if test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->AttrExist("MyAttrib01")=0 then print "Attribut erfolgreich gelscht!" else print "Fehler beim Lschen des Attributs"
'test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->AttrAdd("Hallo", "Test123")
'test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->AttrRemove(2)
'if test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->AttrExist("Hallo")=0 then print "Attribut erfolgreich gelscht!" else print "Fehler beim Lschen des Attributs"
'print
'print "Attribut: "; test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->GetAttr("rdf:about")
'print "Attribut: "; test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->GetAttr(1)
'print "Attribut-ID: "; test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->GetAttrID(1)
'print "Anzahl Attribute: "; test.GetSubTag("rdf:RDF")->GetSubTag("rdf:Description")->AttrCount()


if dir("XMLgen.xml") <> "" then kill "XMLgen.xml"
open "XMLgen.xml" for output as #1
put #1,1,test.ToString()
close #1

'print test.Tag
'print test.Attribute
'print len(test.SubTags)/4

sleep
